import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Dragon here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Dragon  extends Actor
{
    private static int speed = 9;
    public static int hp = 250;
    public static int mp = 60;
    public static int lim = 0;
    public static int dx = 0;
    public static int dy = 0;
    public static int pubx;

    public void moveRight()
    {
        setLocation ( getX() + speed, getY() );
    }

    public void moveLeft()
    {
        setLocation ( getX() - speed, getY() );
    }

    public void moveUp()
    {
        setLocation ( getX(), getY() - speed );
    }

    public void moveDown()
    {
        setLocation ( getX(), getY() + speed );
    }

    public boolean touches(Class clss)
    {
        Actor enemy = getOneIntersectingObject(clss);
        return enemy != null;
    }

    public void remove(Class clss)
    {
        Actor potion = getOneIntersectingObject(clss);
        if(potion != null) {
            getWorld().removeObject(potion);            
        }
    }

    public void placeFireball()
    {
        World Arena= getWorld();
        Arena.addObject(new Fireball(), getX(), getY());
    } 

    public void placeSlash()
    {
        World Arena= getWorld();
        Arena.addObject(new Slash(), getX(), getY());
    }
    public static int peasants;
    public static int princesses;
    public static int knights;
    public static int kings;
    public static int wizards;
    public boolean canMoveRight()
    {
        if (touches(wall.class))
        {
            return false;
        }
        else
        {
            return true;
        }
    }

    public Dragon()
    {
        setImage("Dragon.png");
        speed = 9;
    }

    public void act() 
    {
        pubx = getX();
        if (canMoveRight())
        {
            if (Greenfoot.isKeyDown ("right") )
            {
                moveRight ();
            }
        }

        if (Greenfoot.isKeyDown ("left") )
        {
            moveLeft();
        }
        if (Greenfoot.isKeyDown ("down") )
        {
            moveDown();    
        }
        if (Greenfoot.isKeyDown ("up") )
        {
            moveUp();
        }
        if (Greenfoot.isKeyDown ("1"))
        {
            if (peasants > 0)
            {
                peasants--;
                hp = hp + 5;
            }
        }
        if (Greenfoot.isKeyDown("2"))
        {
            if (princesses > 0)
            {
                princesses--;
                hp = hp +20;
            }
        }
        if (Greenfoot.isKeyDown("3"))
        {
            if (knights > 0)
            {
                knights--;
                hp = hp +50;
            }
        }
        if (Greenfoot.isKeyDown("4"))
        {
            if (kings > 0)
            {
                kings--;
                hp = 250;
            }
        }
        if (Greenfoot.isKeyDown("5"))
        {
            if (wizards > 0)
            {
                wizards--;
                mp = 125;
            }
        }
        //Damage and Status Effects
        if (touches (Feather.class))
        {
            hp = hp - 20;
            remove (Feather.class);
            if (lim != 100)
            {
                lim = lim + 15;
            }
        }
        if (touches (Web.class))
        {
            hp = hp - 5;
            if(speed > 0)
            {
                speed--;
            }
            remove (Web.class);
            if (lim != 100)
            {
                lim = lim + 15;
            }
        }

        if (Atk.option == 1)
        {
            placeSlash();
            Atk.option = 0;
        }
        if (mp > 0)
        {
            if (Atk.option == 2)
            {
                placeFireball();
                lim = lim - 10;
            }
            Atk.option = 0;
        }
        if (lim == 100)
        {
            if (Atk.option == 3)
            {
                lim = 0;
                Atk.option = 0;
            }
        }
            
        if (mp <= 0)
        {
            mp = 0;
        }
        if (lim >= 100)
        {
            lim = 100;
        }
    }    
}