import greenfoot.*; 


public abstract class Scrollable  extends Actor
{
    protected static final int ADD = 1;
    protected static final int REMOVE = 0;

    protected static GreenfootImage image;
    protected int px;
    protected int py;
    protected boolean inWorld;
    
    public Scrollable(int x, int y) {
        px = x;
        py = y;
    }
    
    public int getPX() {
        return px;
    }
    
    public int getPY() {
        return py;
    }
    
    public boolean isInWorld() {
        return inWorld;
    }
    
    public void setState(int i) {
        if(i == ADD) {
            inWorld = true;
        }
        if(i == REMOVE) {
            inWorld = false;
        }
    }
        
    public void act() {
        
    }    
}
